// LED Flash Program
// Program by GucciTech C.H
// 2010/11/13 Version.01
// Softwear HI-TECH C Ver9.80

//#include <pic.h>
#include <htc.h>

// NbN8MHz,MCLRvAbv,MCLR(I/OƂĎgp)
__CONFIG(OSC_8MHZ & MCPUEN & MCLRDIS & WDTDIS & UNPROTECT);

#define _XTAL_FREQ 8000000

#define LED_OUT		GP0
#define SYNC_OUT	GP1
#define EXT_OUT		GP2
#define TRG_IN		GP3

unsigned char		cnt_A;			// Counter A
unsigned char		cnt_ONT;		// Counter ON_Time
unsigned char		cnt_OFFT;		// Counter OFF_Time
unsigned char		cnt_CYLE;		// Counter Cycle
unsigned char		Cyle_Max;		// Cycle-MAX Value
unsigned char		Sync_Tmg;		// Sync OUT Timming
unsigned char		CycleOnFlag;	// Cycle Flag
unsigned char		Time_Flag;		// Cycle Flag

// 100ms Timer Routine //
// ő戵 = (1/X'tal[MHz])*4*197120
//
void delay_100ms(unsigned char time1)
{
	time1 *= 4;							// 4{
	while(time1){
		__delay_ms(25);					// 25ms
		time1--;						// 100ms * time
	}
}

void delay_R01ms(unsigned char time2)
{
	while(time2){
		__delay_us(5);					// 10us
		time2--;
	}
}

main()
{
//	OSCCAL = READ_OSCCAL_DATA();

//----- Initialize -----
//	#asm
//		movwf   OSCCAL					// update register with factory cal value
//		bcf     OSCCAL,0
//	#endasm
//----------------------------

	// I/O Initialize
	OPTION = 0b00000111;				// I/O WeikeUp Enalble
										// GP0=GP1=GP3=Pull-Up 'ON'
	ADCON0 = 0b00000000;				// GP0(AN0)/GP1(AN1)= 'Digital'
	TRISGPIO = 0b00001000;				// GP0=GP1=GP2='OUT',GP3='IN'

	// TODO: USER CODE!!
	LED_OUT = 0;						// LED1 'OFF'
	SYNC_OUT = 1;						// SYNC-OUT 'H'
	Sync_Tmg = 1;                  		// Sync OUT Timing
	Cyle_Max = 9;						// Sycle-MAX Value
	cnt_ONT = 90;
	cnt_OFFT = 100 - cnt_ONT;
	cnt_CYLE = 50;
	CycleOnFlag = 0;
	Time_Flag = 0;
 
	while(1)
	{
		if ((TRG_IN == 0) || (CycleOnFlag == 1))      // TRIGER INPUT 'H' Check!
		{
			CycleOnFlag = 1;
			for (char i=0 ; i <= cnt_CYLE ; i++)
			{
				LED_OUT = 1;				// LED1 'ON'
				delay_R01ms(cnt_ONT);		// LED-'ON' Time
				LED_OUT = 0;				// LED1 'OFF'
				delay_R01ms(cnt_OFFT);		// LED-'OFF' Time
			}
			cnt_A++;
			switch(cnt_A){
				case 1:
					cnt_ONT = 70;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 2:
					cnt_ONT = 50;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 3:
					cnt_ONT = 40;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 4:
					cnt_ONT = 30;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 5:
					cnt_ONT = 25;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 6:
					cnt_ONT = 20;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 7:
					cnt_ONT = 15;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 8:
					cnt_ONT = 10;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				case 9:
					cnt_ONT = 5;
					cnt_OFFT = 100 - cnt_ONT;
					break;
				default:
					break;
			}
			if (cnt_A >= Sync_Tmg){
				SYNC_OUT = 0;				// SYNC-OUT 'L'
			}
			else{
				SYNC_OUT = 1;				// SYNC-OUT 'H'
			}
			if (cnt_A == Cyle_Max){			// Cycle END Check?
				LED_OUT = 0;				// LED1 'OFF'
				SYNC_OUT = 1;				// SYNC-OUT 'H'
				cnt_A = 0;

				cnt_ONT = 90;
				cnt_OFFT = 100 - cnt_ONT;
				cnt_CYLE = 50;

 				if (TRG_IN == 1){
					CycleOnFlag = 0;		// Cycle-ON-Flag '0'
					Time_Flag = 0;
					GPWUF = 0;
					asm("sleep");
					asm("NOP");
					__delay_ms(1);
				}
				else{
					if (Time_Flag == 0){
						delay_100ms(5);		// 0.5sec Delay
						Time_Flag = 1;
					}
					else{
						delay_100ms(50);	// 5sec Delay
						Time_Flag = 0;
					}
				}
			}
			else{
//				cnt_ONT = cnt_ONT - 10;
//	            cnt_OFFT = 100 -cnt_ONT;
				cnt_CYLE = cnt_CYLE - 5;
			}
		}
		else{
			CycleOnFlag = 0;				// Cycle-ON-Flag '0'
			Time_Flag = 0;
			GPWUF = 0;
			asm("sleep");
			asm("NOP");
			__delay_ms(1);
		}
	}
}